C +++
C
C Source: src/source/bm/sradtot.f
C
C ----------------------------------------------
C                SHADOW
C      Center for X-ray Lithography
C     University of Wisconsin-Madison
C  3731 Schneider Dr., Stoughton, WI, 53589
C ----------------------------------------------
C 
C Log:	sradtot.f
C Revision 1.2  90/07/18  19:38:12  khan
C Unixified the programs by removing non standard features, most notably
C DEC's DO .. END DO strucutures.
C 
C Revision 1.1  90/07/11  10:45:04  khan
C Initial revision
C 
C 
C ---

C**************************************************************
C	THIS PROGRAM COMPUTE THE FLUX DISTRIBUTION VS. ELEVATION
C	ANGLE(PSI). THE BANDPASS IS SPECIFIED BY THE USER.
	IMPLICIT REAL*8 (A-H,O-Z)
C
	INCLUDE	'bm.blk'
C
1	CALL INPUT
	CALL SETUP
	CALL COMPUTE
	CALL FILESAVE
	WRITE (6,100)
100	FORMAT(1X,'DONE. ANOTHER RUN (Y/N) ?',$)
	READ(6,110) Q
110	FORMAT(A8)
	IF (Q.EQ.'Y') GO TO 1
	STOP 'SEE YOU LATER !'
	END
C*******************************************************************
	SUBROUTINE INPUT
	IMPLICIT REAL*8 (A-H,O-Z)
C
	INCLUDE	'bm.blk'
	CHARACTER *6 FILSAV,Q
	COMMON/FOURT/FILSAV,Q
C
	WRITE (6,100)
100	FORMAT(1X,'BEAM ENERGY IN GeV = ',$)
	READ(5,*)BENER
	WRITE (6,105)
105	FORMAT(1X,'BEAM CURRENT = ',$)
	READ(5,*)CURR
	WRITE (6,107)
107	FORMAT (1X,'STARTING PHOTON ENERGY = ',$)
	READ(5,*)PHOT1
	WRITE (6,109)
109	FORMAT (1X,'ENDING PHOTON ENERGY = ',$)
	READ(5,*)PHOT2
	WRITE(6,115)
115	FORMAT(1X,'BANDPASS = ',$)
	READ(5,*)BPASS
	WRITE(6,120)
120	FORMAT(1X,'ACCEPTANCE ANGLE IN mrad = ',$)
	READ(5,*)THETA
	WRITE(6,130)
130	FORMAT(1X,'PSI MAXIMUM IN mrad = ',$)
	READ(5,*) PSIMAX
	WRITE(6,140)
140 	FORMAT(1X,'NUMBER OF POINTS (ODD) = ',$)
	READ(5,*)NP
	NP=99
	WRITE (6,150)
150	FORMAT(1X,'NAME FOR STORAGE = ',$)
	READ(6,160) FILSAV
160 	FORMAT (A6)
	RETURN
	END
C*****************************************************************
