C+++
C
C	Locate1, scans a line in the first dimension, looking
C		for the intersection of Vin and  s1(x1) (x1 is
C		is a space coordinate)
C
C		This is a linear interpolation algorithm
C
C---
     	SUBROUTINE Locate1(Nmax, C1, P1, S0, S1, Vin, Vout, Nless)
C
C	NOTE: Vin is only a real number here, not an array, same with
C		Vout
C
     	INTEGER Nmax, Nless, Above, Below
     	REAL*4 S0, S1(42), C1(42), P1(42), Vin, Vout
     	Vin = Vin * S0
     	IF ( Vin .lt. 0) THEN
     		Vin = 0
     	ENDIF
      	Below = 1
     	Above = Nmax
100    	IF (Below .ne. Above) THEN
     		IF (Vin .lt. S0/2) THEN
     			IF (S1(Below + 1) .le. Vin) THEN 
     				Below = Below + 1
     				GOTO 100
     			ELSE IF (S1(Above - 1) .ge. Vin) THEN
     				Above = Above - 1
     				GOTO 100
     			ENDIF
     		ELSE
     			IF (S1(Above - 1) .ge. Vin) THEN
     				Above = Above - 1
     				GOTO 100
     		 	ELSE IF (S1(Below + 1) .le. Vin) THEN 
     				Below = Below + 1
     				GOTO 100
     			ENDIF
     		ENDIF	 
     	ENDIF
     	IF (Above .eq. Below) THEN 
     		Vout = C1(Below)
     	ELSE IF (abs(C1(above) - C1(below)).gt. 1e-28 ) then
     		A = 0.5 * ( P1(above) - P1(below))/(C1(above) -
     $          C1(below) )
		B = (P1(below) * C1(above) - P1(above) * C1(below))/
     $		(C1(above) - C1(below) )
    		C = -1.0 *( A * C1(below) * C1(below) + B * C1(below))  
  	  	IF (Abs(P1(above) - P1(below)) .gt. 1e-28 ) then
			Vout = ((-1.0 * B ) + sqrt(B**2 - (4.0* A * 
     $ 			( C + S1(Below) - Vin ))))/( 2* A)
     		ELSE
     			Vout = 2.0 * ( Vin - S1(Below))/(P1(above) - P1(below))
     $			+ C1(below)
     		ENDIF
	else 
		Vout = C1(below)
     	ENDIF
     	Nless = Below
     	IF ((vout .gt. c1(above)) .or. (vout .lt. c1(below))) THEN
c      		WRITE (6,*) 'LF', C1(Below), Vout, C1(above), P1(below),
c     $		P1(above)
		write(6,*) a,b,c, vout
     	ENDIF
     	RETURN
     	END

